(***********************************************************************)
(*                                                                     *)
(*                             Pio (OCaml)                             *)
(*                                                                     *)
(*                    Polyglot Input/Output Library                    *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2005-2013 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of ocamlprintc.bin generated code *)

let rec print_value_type ppf = function
  | Value_type_def.Scalar_type s ->
    Format.fprintf ppf "@[<1>%s@ " "Scalar_type"; print_scalar_type ppf s;
    Format.fprintf ppf "%,@]"
  | Value_type_def.Vector_type s ->
    Format.fprintf ppf "@[<1>%s@ " "Vector_type"; print_scalar_type ppf s;
    Format.fprintf ppf "%,@]"
  | Value_type_def.Matrix_type s ->
    Format.fprintf ppf "@[<1>%s@ " "Matrix_type"; print_scalar_type ppf s;
    Format.fprintf ppf "%,@]"

and print_scalar_type ppf = function
  | Value_type_def.Bool_type -> Format.fprintf ppf "%s" "Bool_type"
  | Value_type_def.String_type -> Format.fprintf ppf "%s" "String_type"
  | Value_type_def.Int_type -> Format.fprintf ppf "%s" "Int_type"
  | Value_type_def.Native_int_type ->
    Format.fprintf ppf "%s" "Native_int_type"
  | Value_type_def.Int32_type -> Format.fprintf ppf "%s" "Int32_type"
  | Value_type_def.Int64_type -> Format.fprintf ppf "%s" "Int64_type"
  | Value_type_def.Float_type -> Format.fprintf ppf "%s" "Float_type"
  | Value_type_def.Float_bin_type -> Format.fprintf ppf "%s" "Float_bin_type"
  | Value_type_def.Couple_type (s, s0) ->
    Format.fprintf ppf "@[<1>%s@ " "Couple_type";
    Format.fprintf ppf "%,@[<1>(@,"; print_scalar_type ppf s;
    Format.fprintf ppf "%,,@ "; print_scalar_type ppf s0;
    Format.fprintf ppf "%,@,)@]"; Format.fprintf ppf "%,@]"
  | Value_type_def.Triple_type (s, s0, s1) ->
    Format.fprintf ppf "@[<1>%s@ " "Triple_type";
    Format.fprintf ppf "%,@[<1>(@,"; print_scalar_type ppf s;
    Format.fprintf ppf "%,,@ "; print_scalar_type ppf s0;
    Format.fprintf ppf "%,,@ "; print_scalar_type ppf s1;
    Format.fprintf ppf "%,@,)@]"; Format.fprintf ppf "%,@]"
;;

(* End of ocamlprintc.bin generated code *)
